import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;


public class PetList {
	
	static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
	static ArrayList<Pet> pets = new ArrayList<Pet>();
	
	public static void main(String[] args) {
		
		
		while(true) {	
			try {
				System.out.println("\n Choose one of the following:");
				System.out.println("1) Add pet");
				System.out.println("2) List all pets");
				System.out.println("3) Edit pet");
				System.out.println("4) Remove pet");
				System.out.println("5) Quit");
				int read = Integer.parseInt(br.readLine());
				if(read == 1) {
					addPet();
				}
				else if(read == 2) {
					listInfo();
				}
				else if(read == 3) {
					editPet();
				}
				else if(read == 4) {
					removePet();
				}
				else if(read == 5) {
					break;
				}
				else {
					System.out.println("Wrong number, try again");
					continue;
				}
			}			
			catch(Exception e) {
				System.out.println("Wrong input detected, returning to menu.");
				continue;
			}
		}
	}

	private static void removePet() throws Exception {
		listPets();
		System.out.println("\nPet number to remove (type 0 to cancel):");
		int read = Integer.parseInt(br.readLine());
		if(read != 0)
			pets.remove(read - 1);
	}

	private static void editPet() throws Exception {
		listPets();
		System.out.println("\nPet number to edit (type 0 to cancel):");
		int read = Integer.parseInt(br.readLine());
		if(read != 0) {
			Pet p = pets.get(read - 1);
			while(true) {	
				try {
					System.out.println("\n You are currently editing " + p.printInfo() + ". Choose one of the following:");
					System.out.println("1) Edit name:");
					System.out.println("2) Edit age");
					System.out.println("3) Edit type");
					System.out.println("4) Edit sex");
					System.out.println("5) Finished editing");
					read = Integer.parseInt(br.readLine());
					if(read == 1) {
						System.out.println("Enter new name:");
						p.setName(br.readLine());
					}
					else if(read == 2) {
						System.out.println("Enter new age:");
						p.setAge(Integer.parseInt(br.readLine()));
					}
					else if(read == 3) {
						System.out.println("Enter new type:");
						p.setType(br.readLine());
					}
					else if(read == 4) {
						System.out.println("Enter new sex:");
						p.setSex(br.readLine());
					}
					else if(read == 5) {
						break;
					}
					else {
						System.out.println("Wrong number, try again");
						continue;
					}
				}			
				catch(Exception e) {
					System.out.println("Wrong input detected, returning to menu.");
					continue;
				}
			}
		}
	}

	private static void listPets() {
		for(int i = 0; i < pets.size(); i++)
			System.out.println((i + 1) + ". " + pets.get(i).printInfo());
	}
	
	private static void listInfo() {
		listPets();
		System.out.println("Total age: " + totalAge());
		System.out.println("Average age: " + averageAge());
	}
	
	private static void addPet() throws Exception {
		System.out.println("Name:");
		String name = br.readLine();
		System.out.println("Age:");
		int age = Integer.parseInt(br.readLine());
		System.out.println("Type:");
		String type = br.readLine();
		System.out.println("Sex:");
		String sex = br.readLine();
		Pet p = new Pet(name, age, type, sex);
		pets.add(p);
	}
	
	private static int totalAge() {
		int a = 0;
		for(int i = 0; i < pets.size(); i++)
			a += pets.get(i).getAge();
		return a;
	}
	
	private static double averageAge() {
		return 1.0 * totalAge() / pets.size();
	}
	
}
